// Avoid conflict with X11 definitions of True/False
#define GFX_NO_BOOL_MACROS
#include <stdio.h>
#include <gfx/std.h>

#include <gfx/GL/gl.h>
#include <gfx/manip/base.h>

int Manipulator::process_event(const XEvent& event)
{
    switch( event.type )
    {
    case ButtonPress:
	return this->mouse_down(event.xbutton.button, event.xbutton.state,
				event.xbutton.x, event.xbutton.y);

    case ButtonRelease:
	return this->mouse_up(event.xbutton.button, event.xbutton.state,
			      event.xbutton.x, event.xbutton.y);

    case MotionNotify:
	return this->motion(event.xmotion.x, event.xmotion.y);

    default:
	return 0;
    }
}
