#ifndef GFXMANIP_BASE_INCLUDED // -*- C++ -*-
#define GFXMANIP_BASE_INCLUDED

#include <gfx/geom/3D.h>

class Manipulator
{
public:
    //
    // The return values indicate whether the model should be redrawn.
    //
    // The BUTTON and STATE arguments should be the corresponding values
    // passed in from the XEvent.
    //
    virtual int mouse_down(int button, int state, int x, int y) = 0;
    virtual int mouse_up(int button, int state, int x, int y) = 0;
    virtual int motion(int x, int y) = 0;
    virtual int animate() { return 0; }


    virtual void apply() = 0;
    virtual void unapply() = 0;
    virtual void draw() { }

    //
    // Convenience routines
    //
    int process_event(const XEvent& event);
};



// GFXMANIP_BASE_INCLUDED
#endif
